---
title: Element.setAttributeNodeNS()
slug: Web/API/Element/setAttributeNodeNS
tags:
  - API
  - DOM
  - Element
  - Method
  - Reference
---
<div>{{ APIRef("DOM") }}</div>

<p><code>setAttributeNodeNS</code> adds a new namespaced attribute node to an element.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="eval"><em>replacedAttr</em> = element.setAttributeNodeNS(<em>attributeNode</em>)
</pre>

<ul>
 <li><code>replacedAttr</code> is the replaced attribute node, if any, returned by this function.</li>
 <li><code>attributeNode</code> is an <code>Attr</code> node.</li>
</ul>

<h2 id="Example">Example</h2>

<pre class="brush: js">// &lt;div id="one" xmlns:myNS="http://www.mozilla.org/ns/specialspace"
//            myNS:special-align="utterleft"&gt;one&lt;/div&gt;
// &lt;div id="two"&gt;two&lt;/div&gt;

var myns = "http://www.mozilla.org/ns/specialspace";
var d1 = document.getElementById("one");
var d2 = document.getElementById("two");
var a = d1.getAttributeNodeNS(myns, "special-align");
d2.setAttributeNodeNS(a.cloneNode(true));
alert(d2.attributes[1].value) // returns: `utterleft'
</pre>

<h2 id="Notes">Notes</h2>

<p>If the specified attribute already exists on the element, then that attribute is replaced with the new one and the replaced one is returned.</p>

<p>Note that if you try to set without cloning the node, Mozilla gives an NS_ERROR_DOM_INUSE_ATTRIBUTE_ERR "Attribute already in use" error, as the DOM requires cloning for Attr to be reused (unlike other Nodes which can be moved).</p>

<p>{{ DOMAttributeMethods() }}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('DOM WHATWG', '#dom-element-setattributenodens', 'document.setAttributeNodeNS')}}</td>
   <td>{{Spec2('DOM WHATWG')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Element.setAttributeNodeNS")}}</p>
